from microbit import *
uart.init(baudrate=9600, tx = pin8, rx = pin14)

def pilotage(angle):
    impulsion_minimale = 36
    coefficient = 0.37
    return  round(coefficient*angle+impulsion_minimale)


def blocage_1(action):
    pin15.set_analog_period(20)
    if action == "O": #O pour Ouvrir
        pin15.write_analog(pilotage(180))
    if action == "F": #F pour fermer
        pin15.write_analog(pilotage(120))
    sleep(1000)

def blocage_2(action):
    pin16.set_analog_period(20)
    if action == "O": #O pour Ouvrir
        pin16.write_analog(pilotage(180))
    if action == "F": #F pour fermer
        pin16.write_analog(pilotage(60))
    sleep(1000)

while True:
    if pin1.read_digital()==1 and pin2.read_digital()==1:
        display.show("2")
        uart.write("*D02")
    elif pin1.read_digital()==0 and pin2.read_digital()==0:
        display.show("0")
        uart.write("*D00")
    else:
        display.show("1")
        uart.write("*D01")

    if pin1.read_digital()==1:
            blocage_1("F")
    if pin2.read_digital()==1:
            blocage_2("F")

    if uart.any(): #On teste si des données arrivent par l'uart
       	byte = uart.read()
       	msg_str = str(byte, 'UTF-8') #Conversion en UTF-8
        display.show(msg_str)
       	if msg_str == "E1":
            blocage_1("O")
            sleep(2000)
        elif msg_str == "E2":
            blocage_2("O")
            sleep(2000)

