from microbit import *
import radio

radio.config(address = 1, group = 10)
radio.on()

def pilotage(angle):
    impulsion_minimale = 36
    coefficient = 0.37
    return  round(coefficient*angle+impulsion_minimale)


def blocage_1(action):
    pin15.set_analog_period(20)
    if action == "O": #O pour Ouvrir
        pin15.write_analog(pilotage(180))
    if action == "F": #F pour fermer
        pin15.write_analog(pilotage(120))
    sleep(1000)

def blocage_2(action):
    pin16.set_analog_period(20)
    if action == "O": #O pour Ouvrir
        pin16.write_analog(pilotage(0))
    if action == "F": #F pour fermer
        pin16.write_analog(pilotage(100))
    sleep(1000)

#######
blocage_1("O")
blocage_2("O")

while True:
    donnees_recues = radio.receive()
    if pin1.read_digital()==1:
        blocage_1("F")
    if pin2.read_digital()==1:
        blocage_2("F")
    if button_a.was_pressed() or donnees_recues == "E2":
        blocage_2("O")
    if button_b.was_pressed() or donnees_recues == "E1":
        blocage_1("O")

    if pin1.read_digital()==1 and pin2.read_digital()==1:
        display.show("2")
        radio.send("2")
    elif pin1.read_digital()==0 and pin2.read_digital()==0:
        display.show("0")
        radio.send("0")
    else:
        display.show("1")
        radio.send("1")